<!doctype html>
<html lang="en">

<head>
    <title>Title</title>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <!-- Bootstrap CSS -->
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css"
        integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">
</head>

<body>
    <div class="container-fluid">
        <h3 class="text-center mb-3 mt-3">DANH SÁCH NGƯỜI DÙNG</h3>
        <div class="row mb-4 ml-5">
            <label for="" class="ml-5 mr-5">Name</label>
            <input type="text" name="" id="inp-name" class="col-sm-5 form-control">
            <button id="btn-filter" class="btn btn-success ml-5">Lọc User</button>

        </div>
        <table id="table-users" class="table table-bordered table-striped">
            <thead>
                <tr class="bg-primary text-white">
                    <th>STT</th>
                    <th>Name</th>
                    <th>UserName</th>
                    <th>Email</th>
                    <th>Address</th>
                    <th>ZipCode</th>
                    <th>Phone</th>
                    <th>Company</th>
                    <th>Action</th>
                </tr>
            </thead>
            <tbody class="table-primary">

            </tbody>
        </table>
    </div>


</body>
<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    var gUserArray = [];
    const gBASE_URL = "https://jsonplaceholder.typicode.com/users/";
    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
    $(document).ready(function () {
        onPageLoading();
        $("#table-users").on("click", ".btn-detail", function () {
            onBtnDetail(this);
        })
        $("#btn-filter").on("click", function () {
            onBtnFilterUser();
        })

    })
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    function onPageLoading() {
        $.ajax({
            url: gBASE_URL,
            type: "GET",
            success: function (res) {
                console.log(res);
                gUserArray = res;
                fillDataTableUser(res);
            },
            error: function (error) {
                console.log(error.status);
            }

        })
    }
    function onBtnDetail(paramUser) {
        var vId = $(paramUser).data("id");
        console.log(vId);
        var vLink = "UserDetail35.html";
        window.location.href = vLink + "?id=" + vId;
    }

    // filter
    function onBtnFilterUser() {
        var vUserObj = {
            name: "",
        }
        getDataUserName(vUserObj);
        $("#table-users").find("tr:gt(0)").html("");
        var vArrayFilter = fillDataUserName(vUserObj);
        if (vArrayFilter.length > 0) {
            alert("tìm thấy user đã nhập");
            fillDataTableUser(vArrayFilter);
        }
        else {
            alert("không tìm thấy tên user đã nhập")
            return false;
        }

    }
    // 
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    function fillDataTableUser(paramRes) {
        for (var bI = 0; bI < paramRes.length; bI++) {
            $("#table-users")
                .find("tbody")
                .append($("<tr/>")
                    .append($("<td/>")
                        .html(bI + 1)
                    )
                    .append($("<td/>")
                        .html(paramRes[bI].name)
                    )
                    .append($("<td/>")
                        .html(paramRes[bI].username)
                    )
                    .append($("<td/>")
                        .html(paramRes[bI].email)
                    )
                    .append($("<td/>")
                        .html(paramRes[bI].address.street + "," + paramRes[bI].address.suite + "," + paramRes[bI].address.city)
                    )
                    .append($("<td/>")
                        .html(paramRes[bI].address.zipcode)
                    )
                    .append($("<td/>")
                        .html(paramRes[bI].phone)
                    )
                    .append($("<td/>")
                        .html(paramRes[bI].company.name)
                    )
                    .append($("<td/>")
                        .append($("<button/>")
                            .html("Detail")
                            .addClass("btn btn-success btn-detail")
                            .data("id", paramRes[bI].id)

                        )
                    )
                )
        }

    }
    // thu thap thong tin name filter
    function getDataUserName(paramUser) {
        paramUser.name = $("#inp-name").val().trim();
    }
    // loc name 
    function fillDataUserName(paramUser) {
        var vUserResult = [];
        if (paramUser.name != "") {
            for (var bI = 0; bI < gUserArray.length; bI++) {
                if (paramUser.name == gUserArray[bI].name) {
                    vUserResult.push(gUserArray[bI]);
                }
            }
        }
        return vUserResult;
    }
</script>

</html>